package ru.dbotthepony.mc.otm.datagen

import net.minecraft.core.Direction
import net.minecraft.resources.ResourceLocation
import net.minecraftforge.client.model.generators.BlockStateProvider
import net.minecraftforge.eventbus.api.SubscribeEvent
import net.minecraftforge.fml.common.Mod
import net.minecraftforge.forge.event.lifecycle.GatherDataEvent
import ru.dbotthepony.mc.otm.OverdriveThatMatters
import ru.dbotthepony.mc.otm.Registry
import ru.dbotthepony.mc.otm.block.BlockBatteryBank
import ru.dbotthepony.mc.otm.block.BlockMatteryRotatable
import ru.dbotthepony.mc.otm.toYRotBlockstate

fun nothingOrNumber(input: Int): String {
	if (input == 0)
		return ""

	return (input - 1).toString()
}

@Mod.EventBusSubscriber(modid = DataGen.MOD_ID, bus = Mod.EventBusSubscriber.Bus.MOD)
object DataGen {
	const val MOD_ID = OverdriveThatMatters.MOD_ID

	@SubscribeEvent
	@JvmStatic
	fun onGatherData(event: GatherDataEvent) {
		event.generator.addProvider(object : BlockStateProvider(event.generator, MOD_ID, event.existingFileHelper) {
			override fun registerStatesAndModels() {
				with(getMultipartBuilder(Registry.Blocks.BATTERY_BANK)) {
					val battery_bank = models().getExistingFile(ResourceLocation("overdrive_that_matters:block/battery_bank"))

					BlockMatteryRotatable.FACING.possibleValues.forEach {
						part().modelFile(battery_bank).rotationY(it.toYRotBlockstate()).addModel().condition(BlockMatteryRotatable.FACING, it)

						for (i in 0 .. 5) {
							part().modelFile(
								models().getExistingFile(ResourceLocation("overdrive_that_matters:block/battery/battery_front${nothingOrNumber(i)}"))
							).rotationY(it.toYRotBlockstate()).addModel()
								.condition(BlockMatteryRotatable.FACING, it)
								.condition(BlockBatteryBank.BATTERY_SLOTS_PROPS[i], true)
						}

						for (i in 6 .. 11) {
							part().modelFile(
								models().getExistingFile(ResourceLocation("overdrive_that_matters:block/battery/battery_back${nothingOrNumber(i - 6)}"))
							).rotationY(it.toYRotBlockstate()).addModel()
								.condition(BlockMatteryRotatable.FACING, it)
								.condition(BlockBatteryBank.BATTERY_SLOTS_PROPS[i], true)
						}
					}
				}
			}
		})
	}
}
